import React, { Dispatch, SetStateAction, ReactNode } from 'react';
import { RuleFn } from 'rules';
export declare type Values = {
    [key: string]: string;
};
export declare type ValuesBlurred = {
    [key: string]: boolean;
};
export declare type Rules = {
    [key: string]: RuleFn;
};
export declare type Error = {
    name: string;
    message: string;
};
declare type Context = {
    rules: Rules;
    values: Values;
    errors: Error[];
    valuesBlurred: ValuesBlurred;
    hasBlurred: (name: string) => any;
    setErrors: Dispatch<SetStateAction<Error[]>>;
    updateValue: (name: string, value: string) => any;
};
declare const FormContext: React.Context<Context>;
export declare type FormProps = {
    rules: Rules;
    values: Values;
    children: ReactNode;
    onValues: Dispatch<SetStateAction<any>>;
};
declare const Form: ({ children, onValues, values, rules }: FormProps) => JSX.Element;
declare const FormContextConsumer: React.Consumer<Context>;
export { FormContext, Form, FormContextConsumer };
